Package javax.mail.internet

## Class InternetHeaders

- java.lang.Object
- - javax.mail.internet.InternetHeaders

    public class InternetHeaders
    extends Object

InternetHeaders is a utility class that manages RFC822 style headers. Given an RFC822 format message stream, it reads lines until the blank line that indicates end of header. The input stream is positioned at the start of the body. The lines are stored within the object and can be extracted as either Strings or `Header` objects.

This class is mostly intended for service providers. MimeMessage and MimeBody use this class for holding their headers.

A note on RFC822 and MIME headers

RFC822 and MIME header fields must contain only US-ASCII characters. If a header contains non US-ASCII characters, it must be encoded as per the rules in RFC 2047. The MimeUtility class provided in this package can be used to to achieve this. Callers of the `setHeader`, `addHeader`, and `addHeaderLine` methods are responsible for enforcing the MIME requirements for the specified headers. In addition, these header fields must be folded (wrapped) before being sent if they exceed the line length limitation for the transport (1000 bytes for SMTP). Received headers may have been folded. The application is responsible for folding and unfolding headers as appropriate.

The current implementation supports the System property `mail.mime.ignorewhitespacelines`, which if set to true will cause a line containing only whitespace to be considered a blank line terminating the header.

Author:
  John Mani, Bill Shannon
See Also:
  `MimeUtility`

### Nested Class Summary

Nested Classes
`protected static class` `InternetHeaders.InternetHeader` An individual internet header.

### Field Summary

Fields
`protected List<InternetHeaders.InternetHeader>` `headers` The actual list of Headers, including placeholder entries.

### Constructor Summary

Constructors
`InternetHeaders​()` Create an empty InternetHeaders object.
`InternetHeaders​(InputStream is)` Read and parse the given RFC822 message stream till the blank line separating the header from the body.
`InternetHeaders​(InputStream is, boolean allowutf8)` Read and parse the given RFC822 message stream till the blank line separating the header from the body.

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addHeader​(String name, String value)` Add a header with the specified name and value to the header list.
`void` `addHeaderLine​(String line)` Add an RFC822 header line to the header store.
`Enumeration<String>` `getAllHeaderLines​()` Return all the header lines as an Enumeration of Strings.
`Enumeration<Header>` `getAllHeaders​()` Return all the headers as an Enumeration of `Header` objects.
`String[]` `getHeader​(String name)` Return all the values for the specified header.
`String` `getHeader​(String name, String delimiter)` Get all the headers for this header name, returned as a single String, with headers separated by the delimiter.
`Enumeration<String>` `getMatchingHeaderLines​(String[] names)` Return all matching header lines as an Enumeration of Strings.
`Enumeration<Header>` `getMatchingHeaders​(String[] names)` Return all matching `Header` objects.
`Enumeration<String>` `getNonMatchingHeaderLines​(String[] names)` Return all non-matching header lines
`Enumeration<Header>` `getNonMatchingHeaders​(String[] names)` Return all non-matching `Header` objects.
`void` `load​(InputStream is)` Read and parse the given RFC822 message stream till the blank line separating the header from the body.
`void` `load​(InputStream is, boolean allowutf8)` Read and parse the given RFC822 message stream till the blank line separating the header from the body.
`void` `removeHeader​(String name)` Remove all header entries that match the given name
`void` `setHeader​(String name, String value)` Change the first header line that matches name to have value, adding a new header if no existing header matches.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### headers

    protected List<InternetHeaders.InternetHeader> headers

The actual list of Headers, including placeholder entries. Placeholder entries are Headers with a null value and are never seen by clients of the InternetHeaders class. Placeholder entries are used to keep track of the preferred order of headers. Headers are never actually removed from the list, they're converted into placeholder entries. New headers are added after existing headers of the same name (or before in the case of `Received` and `Return-Path` headers). If no existing header or placeholder for the header is found, new headers are added after the special placeholder with the name ":".

Since:
  JavaMail 1.4

### Constructor Detail

#### InternetHeaders

    public InternetHeaders​()

Create an empty InternetHeaders object. Placeholder entries are inserted to indicate the preferred order of headers.

#### InternetHeaders

    public InternetHeaders​(InputStream is)
                    throws MessagingException

Read and parse the given RFC822 message stream till the blank line separating the header from the body. The input stream is left positioned at the start of the body. The header lines are stored internally.

For efficiency, wrap a BufferedInputStream around the actual input stream and pass it as the parameter.

No placeholder entries are inserted; the original order of the headers is preserved.

Parameters:
  `is` - RFC822 input stream
Throws:
  `MessagingException` - for any I/O error reading the stream

#### InternetHeaders

    public InternetHeaders​(InputStream is,
                           boolean allowutf8)
                    throws MessagingException

Read and parse the given RFC822 message stream till the blank line separating the header from the body. The input stream is left positioned at the start of the body. The header lines are stored internally.

For efficiency, wrap a BufferedInputStream around the actual input stream and pass it as the parameter.

No placeholder entries are inserted; the original order of the headers is preserved.

Parameters:
  `is` - RFC822 input stream
  `allowutf8` - if UTF-8 encoded headers are allowed
Throws:
  `MessagingException` - for any I/O error reading the stream
Since:
  JavaMail 1.6

### Method Detail

#### load

    public void load​(InputStream is)
              throws MessagingException

Read and parse the given RFC822 message stream till the blank line separating the header from the body. Store the header lines inside this InternetHeaders object. The order of header lines is preserved.

Note that the header lines are added into this InternetHeaders object, so any existing headers in this object will not be affected. Headers are added to the end of the existing list of headers, in order.

Parameters:
  `is` - RFC822 input stream
Throws:
  `MessagingException` - for any I/O error reading the stream

#### load

    public void load​(InputStream is,
                     boolean allowutf8)
              throws MessagingException

Read and parse the given RFC822 message stream till the blank line separating the header from the body. Store the header lines inside this InternetHeaders object. The order of header lines is preserved.

Note that the header lines are added into this InternetHeaders object, so any existing headers in this object will not be affected. Headers are added to the end of the existing list of headers, in order.

Parameters:
  `is` - RFC822 input stream
  `allowutf8` - if UTF-8 encoded headers are allowed
Throws:
  `MessagingException` - for any I/O error reading the stream
Since:
  JavaMail 1.6

#### getHeader

    public String[] getHeader​(String name)

Return all the values for the specified header. The values are String objects. Returns `null` if no headers with the specified name exist.

Parameters:
  `name` - header name
Returns:
  array of header values, or null if none

#### getHeader

    public String getHeader​(String name,
                            String delimiter)

Get all the headers for this header name, returned as a single String, with headers separated by the delimiter. If the delimiter is `null`, only the first header is returned. Returns `null` if no headers with the specified name exist.

Parameters:
  `name` - header name
  `delimiter` - delimiter
Returns:
  the value fields for all headers with this name, or null if none

#### setHeader

    public void setHeader​(String name,
                          String value)

Change the first header line that matches name to have value, adding a new header if no existing header matches. Remove all matching headers but the first.

Note that RFC822 headers can only contain US-ASCII characters

Parameters:
  `name` - header name
  `value` - header value

#### addHeader

    public void addHeader​(String name,
                          String value)

Add a header with the specified name and value to the header list.

The current implementation knows about the preferred order of most well-known headers and will insert headers in that order. In addition, it knows that `Received` headers should be inserted in reverse order (newest before oldest), and that they should appear at the beginning of the headers, preceeded only by a possible `Return-Path` header.

Note that RFC822 headers can only contain US-ASCII characters.

Parameters:
  `name` - header name
  `value` - header value

#### removeHeader

    public void removeHeader​(String name)

Remove all header entries that match the given name

Parameters:
  `name` - header name

#### getAllHeaders

    public Enumeration<Header> getAllHeaders​()

Return all the headers as an Enumeration of `Header` objects.

Returns:
  Enumeration of Header objects

#### getMatchingHeaders

    public Enumeration<Header> getMatchingHeaders​(String[] names)

Return all matching `Header` objects.

Parameters:
  `names` - the headers to return
Returns:
  Enumeration of matching Header objects

#### getNonMatchingHeaders

    public Enumeration<Header> getNonMatchingHeaders​(String[] names)

Return all non-matching `Header` objects.

Parameters:
  `names` - the headers to not return
Returns:
  Enumeration of non-matching Header objects

#### addHeaderLine

    public void addHeaderLine​(String line)

Add an RFC822 header line to the header store. If the line starts with a space or tab (a continuation line), add it to the last header line in the list. Otherwise, append the new header line to the list.

Note that RFC822 headers can only contain US-ASCII characters

Parameters:
  `line` - raw RFC822 header line

#### getAllHeaderLines

    public Enumeration<String> getAllHeaderLines​()

Return all the header lines as an Enumeration of Strings.

Returns:
  Enumeration of Strings of all header lines

#### getMatchingHeaderLines

    public Enumeration<String> getMatchingHeaderLines​(String[] names)

Return all matching header lines as an Enumeration of Strings.

Parameters:
  `names` - the headers to return
Returns:
  Enumeration of Strings of all matching header lines

#### getNonMatchingHeaderLines

    public Enumeration<String> getNonMatchingHeaderLines​(String[] names)

Return all non-matching header lines

Parameters:
  `names` - the headers to not return
Returns:
  Enumeration of Strings of all non-matching header lines